Subject: Re: clear-screen widget and prompt expansion
From: Vincent Lefevre <[email-masked]>
To: [email-masked]
Date: Tue, 16 Feb 2016 11:01:40 +0100
List-Id: Zsh Workers List <zsh-workers.zsh.org>

On 2016-02-04 07:37:31 -0800, Bart Schaefer wrote:
> On Feb 4,  3:12pm, Vincent Lefevre wrote:
> } Shouldn't the prompt also be re-expanded (like when the screen is
> } resized)? Or is it up to the user to create a new widget for that?
> 
> There was a deliberate decision made a long time ago that once ZLE
> is started, the prompt is a relatively static part of the editor.
> Originally this was because prompts are formatted by the shell (even
> if ZLE is disabled) and ZLE was treated like a separate entity.
> 
> Window resize is particularly tricky because, depending on the window
> manager/desktop application, SIGWINCH may be sent either only once
> when the user releases the mouse button (or otherwise ends the drag-
> resize operation), or multiple times in very rapid succession for every
> incremental drag motion.
> 
> So it's left up to the user to decide how to handle that, typically by
> something like
>     TRAPWINCH() { zle && zle reset-prompt }

I meant that prompt is already re-expanded when the terminal is
resized. What I'm saying is that clear-screen is not consistent
with that. For instance, with RPS1="<%*" after "zsh -f", when
resizing the terminal, the time is updated, but with Ctrl-L it
is not. I'm wondering whether such a difference is expected.

Moreover I thought that

  zle -A clear-screen real-clear-screen
  cls-rp() { zle real-clear-screen; zle reset-prompt }
  zle -N clear-screen cls-rp

would do what I expect, but this doesn't work in incremental search
mode (while the prompt is still re-expanded when the terminal is
resized).

-- 
Vincent Lefèvre <[email-masked]> - Web: <https://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <https://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / AriC project (LIP, ENS-Lyon)